# -*- encoding: utf-8 -*-
#################################################################################
#                                                                               #
#    Model module for OpenERP                                                   #
#    Copyright (C) 2010 Sébastien BEAU <sebastien.beau@akretion.comr>           #
#                                                                               #
#    This program is free software: you can redistribute it and/or modify       #
#    it under the terms of the GNU Affero General Public License as             #
#    published by the Free Software Foundation, either version 3 of the         #
#    License, or (at your option) any later version.                            #
#                                                                               #
#    This program is distributed in the hope that it will be useful,            #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of             #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              #
#    GNU Affero General Public License for more details.                        #
#                                                                               #
#    You should have received a copy of the GNU Affero General Public License   #
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.      #
#                                                                               #
#################################################################################

from osv import osv, fields
import netsvc
from tools.translate import _

class res_users(osv.osv):
    _inherit = "res.users"

    def is_super_administrator(self, cr, uid):
        ir_model_data_obj = self.pool.get('ir.model.data')
        id = ir_model_data_obj.search(cr, uid, [['name', '=', 'group_super_administrator'], ['module', '=', 'super_administrator']])
        if len(id) != 1:
            return False
        id=id[0]
        super_admin_group_id = ir_model_data_obj.read(cr, uid, id, ['res_id'])['res_id']
        user_id_ok = self.search(cr, uid, [['id', '=', uid],['groups_id', '=', super_admin_group_id]])
        print 
        if user_id_ok:
            return True
        return False

res_users()


class stock_picking(osv.osv):
    _inherit = "stock.picking"

    def undo_picking(self, cr, uid, ids, context=None):
        if not self.pool.get('res.users').is_super_administrator(cr, uid):
            raise osv.except_osv(_('User Error !'),_('You are not a super administrator'))
        else:
            wf_service = netsvc.LocalService("workflow")

            #UNDO the picking and the stock move
            picking_obj = self.pool.get('stock.picking')
            picking_obj.write(cr, uid, ids, {'state' : 'assigned', 'date_done': False}, context=context)
            move_obj = self.pool.get('stock.move')
            move_ids = move_obj.search(cr, uid, [['picking_id', 'in', ids]], context=context)
            move_obj.write(cr, uid, move_ids, {'state' : 'assigned'}) #'date_planned': '2011-03-01 00:59:03' TO FIX IN OPENERP V6 date planned don't existe anymore!!!
            for picking_id in ids:
                cr.execute("update wkf_instance set state='active' where res_id=%s and res_type='stock.picking'", (picking_id,))
                wf_service.trg_validate(uid, 'stock.picking', picking_id, 'button_undo', cr)

            #UNDO the procurement order
            po_obj = self.pool.get('procurement.order')
            po_ids = po_obj.search(cr, uid, [['move_id', 'in', move_ids]], context=context)
            po_obj.write(cr, uid, po_ids, {'state': 'ready', 'date_close': False}, context=context)
            for po_id in po_ids:
                cr.execute("update wkf_instance set state='active' where res_id=%s and res_type='procurement.order'", (po_id,))
                wf_service.trg_validate(uid, 'procurement.order', po_id, 'button_unship', cr)

            #UNDO the sale order line and sale order
            so_line_ids = [x['sale_line_id'][0] for x in move_obj.read(cr, uid, move_ids, ['sale_line_id'], context=context)]
            so_line_obj = self.pool.get('sale.order.line')
            so_line_obj.write(cr, uid, so_line_ids, {'state' : 'confirmed'}, context=context)
            so_ids = [x['order_id'][0] for x in so_line_obj.read(cr, uid, so_line_ids, ['order_id'], context=context)]
            self.pool.get('sale.order').write(cr, uid, so_ids, {'shipped' : False}, context=context)
            for so_id in so_ids:
                cr.execute("update wkf_instance set state='active' where res_id=%s and res_type='sale.order'", (so_id,))
                wf_service.trg_validate(uid, 'sale.order', so_id, 'button_unship', cr)

        return True

stock_picking()

    
    
